## gfal2 2.7.8

=== CMakeLists.txt ===
## cmake build script for srm-ifce
project (gfal2)
cmake_minimum_required (VERSION 2.6)
message("cmake source dir : ${CMAKE_SOURCE_DIR}")

# default set of options
SET(MAIN_CORE TRUE
        CACHE STRING "enable compilation of the main library")
SET(MAIN_TRANSFER TRUE
        CACHE STRING "enable compilation of the transfer library")

SET(PLUGIN_LFC TRUE
        CACHE STRING "enable compilation of the lfc plugin")
SET(PLUGIN_SRM TRUE
        CACHE STRING "enable compilation of the srm plugin")
SET(PLUGIN_RFIO TRUE
        CACHE STRING "enable compilation of the RFIO plugin")
SET(PLUGIN_DCAP TRUE
        CACHE STRING "enable compilation of the DCAP plugin")
SET(PLUGIN_FILE TRUE
        CACHE STRING "enable compilation of the local File plugin")
SET(PLUGIN_GRIDFTP TRUE
        CACHE STRING "enable compilation of the GRIDFTP plugin")
SET(PLUGIN_HTTP TRUE
        CACHE STRING "enable compilation of the HTTP plugin")
SET(PLUGIN_MOCK FALSE
        CACHE STRING "enable compilation of the MOCK plugin")

# build type
set(CMAKE_BUILD_TYPE "RelWithDebInfo"
	CACHE STRING "type of build")

set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake/modules/")
# load module
include(DefineInstallationPaths REQUIRED)
include(MacroCopyFile REQUIRED)
include(ReleaseDebugAutoFlags REQUIRED)
include(CMakeGeneratePkgConfig REQUIRED)
include(MacroAddDoxygen REQUIRED)

find_package(PkgConfig REQUIRED)

#enable testing
INCLUDE(CTest)

#define PROJECT vars
set(PROJECT_NAME_MAIN "gfal2")
set(OUTPUT_NAME_MAIN "gfal2")

set(PROJECT_NAME_TRANSFER "gfal_transfer")
set(OUTPUT_NAME_TRANSFER "gfal_transfer")

set(VERSION_MAJOR  2)
set(VERSION_MINOR  7)
set(VERSION_PATCH  8)
set(VERSION_STRING ${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH})


# out of project test compilation
SET(ONLY_TESTS FALSE
	CACHE STRING "enable or disable out of project dir")

# libs checks
pkg_check_modules(GLIB2_PKG REQUIRED glib-2.0)
pkg_check_modules(GTHREAD2_PKG REQUIRED gthread-2.0)

# include directories
include_directories(${GLIB2_PKG_INCLUDE_DIRS})
include_directories(${GTHREAD2_PKG_INCLUDE_DIRS})
include_directories(${CMAKE_SOURCE_DIR}/src/core)
include_directories(${CMAKE_SOURCE_DIR}/src/utils)


# Core and plugins
IF(NOT ONLY_TESTS)
    pkg_search_module(GLIBMM_PKG REQUIRED glibmm glibmm-2.6 glibmm-2.4)
    pkg_check_modules(UUID_PKG REQUIRED uuid)

    include_directories(${GLIBMM_PKG_INCLUDE_DIRS})

   # general parameters for configuration
    add_definitions( -DGFAL_PLUGIN_DIR_DEFAULT="${PLUGIN_INSTALL_DIR}" )
    add_definitions( -DGFAL_CONFIG_DIR_DEFAULT="${SYSCONF_INSTALL_DIR}" )
    # add file offset 64 for 32 bits
    add_definitions( -D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE -D_LARGEFILE64_SOURCE -D_GNU_SOURCE)

    #install doc license
    install(FILES "LICENSE" "README" "RELEASE-NOTES" "DESCRIPTION"
			DESTINATION ${DOC_INSTALL_DIR})
			
    # install global configuration files
    LIST(APPEND lst_conf_files "${CMAKE_SOURCE_DIR}/dist/etc/gfal2.d/gfal2_core.conf" "${CMAKE_SOURCE_DIR}/dist/etc/gfal2.d/bdii.conf")
    install(FILES ${lst_conf_files}
                        DESTINATION ${SYSCONF_INSTALL_DIR}/gfal2.d/)


    add_subdirectory (doc)
    add_subdirectory (src)

ENDIF(NOT ONLY_TESTS)

add_subdirectory (test)

=== test/CMakeLists.txt ===
## src cmake build script for srm-ifce

## default set of build
SET(UNIT_TESTS FALSE
	CACHE STRING "enable compilation of unit tests")
SET(FUNCTIONAL_TESTS FALSE
	CACHE STRING "functional tests for gfal ")
SET(STRESS_TESTS FALSE
        CACHE STRING "stress tests for gfal ")
	

if(ONLY_TESTS)
	pkg_check_modules(GFAL2_PKG REQUIRED gfal2)
	pkg_check_modules(GFAL2_TRANSFER_PKG REQUIRED gfal_transfer)
	set(GFAL2_LINK ${GFAL2_PKG_LIBRARIES})
	set(GFAL2_TRANSFER_LINK ${GFAL2_TRANSFER_PKG_LIBRARIES})
        pkg_search_module(GLIBMM_PKG REQUIRED glibmm glibmm-2.6 glibmm-2.4)
    include_directories(${GFAL2_PKG_INCLUDE_DIRS})
    include_directories(${GFAL2_TRANSFER_PKG_INCLUDE_DIRS})
else(ONLY_TESTS)
  set(GFAL2_LINK gfal2)
  set(GFAL2_TRANSFER_LINK gfal2_transfer)
endif(ONLY_TESTS)

execute_process(COMMAND cmake -E copy_directory ${CMAKE_CURRENT_SOURCE_DIR}/conf_test  ${CMAKE_CURRENT_BINARY_DIR}/conf_test) 

# Common methods for the tests
add_subdirectory(common)
include_directories(.)
include_directories(../src/externals)

# Tests
add_subdirectory(unit)
add_subdirectory(functional)
add_subdirectory(stress-test)


# Disabled
# It may be interesting to adapt, so keep them
# add_subdirectory(old-gfal-tests)

=== src/core/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.6)

# Sources needed for the core library
file (GLOB src_cancel     "cancel/*.c*")
file (GLOB src_common     "common/*.c" "common/future/*.c")
file (GLOB src_config     "config/*.c")
file (GLOB src_exceptions "exceptions/*.c*")
file (GLOB src_gconfig    "g_config_manager/*.c*")
file (GLOB src_file       "file/*.c*")
file (GLOB src_global     "global/*c*")
file (GLOB src_logger     "logger/*.c*")
file (GLOB src_posix      "posix/*.c*")

# Core library
add_definitions(-DVERSION="${VERSION_STRING}")
add_definitions(-D__GFAL2_BUILD__)

add_library (gfal2 SHARED ${src_cancel}
                          ${src_common}
                          ${src_config}
                          ${src_gconfig}
                          ${src_file}
                          ${src_global}
                          ${src_logger}
                          ${src_posix}
                          ${src_exception}
                          ${gfal2_utils_c_src})

target_link_libraries (gfal2 ${UUID_PKG_LIBRARIES} "stdc++" ) # hotfix for libc TLS init bug in EPEL 5
target_link_libraries (gfal2 ${GLIB2_PKG_LIBRARIES} ${GTHREAD2_PKG_LIBRARIES})
target_link_libraries (gfal2 "dl")

set_target_properties (gfal2 PROPERTIES
                             VERSION ${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH}
                             SOVERSION ${VERSION_MAJOR}
                             CLEAN_DIRECT_OUTPUT 1
                             OUTPUT_NAME ${OUTPUT_NAME_MAIN})

# pkgconfig for gfal2
add_PkgConfigFile_for_Library ("gfal2.pc" gfal2
                                        HEADER_DIRS "gfal2"
                                        CFLAGS " -D_FILE_OFFSET_BITS=64 "
                                        DESCRIPTION "GFAL 2.0 pkgconfig file"
                                        REQUIRES "glib-2.0")

# Install core library
install (TARGETS gfal2 LIBRARY DESTINATION ${LIB_INSTALL_DIR})
install (FILES ${CMAKE_CURRENT_BINARY_DIR}/gfal2.pc DESTINATION ${PKGCONFIG_FILES_DIR})

# Install development headers
install (FILES "gfal_api.h" "gfal_plugins_api.h"
         DESTINATION ${INCLUDE_INSTALL_DIR}/gfal2/)
install (FILES "cancel/gfal_cancel.h"
         DESTINATION ${INCLUDE_INSTALL_DIR}/gfal2/cancel)
install (FILES "logger/gfal_logger.h"
         DESTINATION ${INCLUDE_INSTALL_DIR}/gfal2/logger)
install (FILES "posix/gfal_posix_api.h"
         DESTINATION ${INCLUDE_INSTALL_DIR}/gfal2/posix)
install (FILES "common/gfal_constants.h"
               "common/gfal_common_plugin_interface.h"
               "common/gfal_prototypes.h"
               "common/gfal_common_plugin.h"
               "common/gfal_types.h"
               "common/gfal_deprecated.h"
               "common/gfal_common_err_helpers.h"
         DESTINATION ${INCLUDE_INSTALL_DIR}/gfal2/common)
install (FILES "global/gfal_global.h"
         DESTINATION ${INCLUDE_INSTALL_DIR}/gfal2/global)
install (FILES "config/gfal_config.h"
         DESTINATION ${INCLUDE_INSTALL_DIR}/gfal2/config)
install (FILES "g_config_manager/g_config_manager.h"
         DESTINATION ${INCLUDE_INSTALL_DIR}/gfal2/g_config_manager)
install (FILES "file/gfal_file_api.h"
         DESTINATION ${INCLUDE_INSTALL_DIR}/gfal2/file)
install (FILES "fdesc/gfal_file_handle.h"
         DESTINATION ${INCLUDE_INSTALL_DIR}/gfal2/fdesc)

# Transfer library
if (MAIN_TRANSFER)
    add_subdirectory (transfer)
endif (MAIN_TRANSFER)

=== test/common/CMakeLists.txt ===
find_package(GTEST)

include_directories(${GTEST_INCLUDE_DIR})

add_library(test_shared SHARED gfal_lib_test.c gfal_gtest_asserts.cpp)

target_link_libraries (test_shared ${GFAL2_TRANSFER_LINK} ${GTEST_LIBRARIES})

=== test/functional/CMakeLists.txt ===
#
# compilation lines for examples


#${GTEST_LIBRARIES} ${GTEST_MAIN_LIBRARIES}

SET(COPY_SRC "*.sh")
SET(COPY_DST "${CMAKE_CURRENT_BINARY_DIR}/")

IF (FUNCTIONAL_TESTS)
        find_package(GTEST)

        include_directories(
            "${CMAKE_SOURCE_DIR}/src"
            "${CMAKE_SOURCE_DIR}/src/posix/"
            ${GLIB2_PKG_INCLUDE_DIRS}
            ${GTEST_INCLUDE_DIR}
        )
        
        add_executable(gfal_test_bringonline "gfal_test_bringonline.cpp")
        target_link_libraries(gfal_test_bringonline ${GFAL2_LINK} test_shared)
        FUNCTION(test_bringonline name dir_path)
                add_test(gfal_test_bringonline_${name} gfal_test_bringonline ${dir_path})
        ENDFUNCTION(test_bringonline name valid_file)

        add_executable(gfal_test_checksum "gfal_test_checksum.c")
        target_link_libraries(gfal_test_checksum ${GFAL2_LINK} test_shared)

        add_executable(gfal_stat        "gfal_stat.c")
        target_link_libraries(gfal_stat ${GFAL2_LINK})

        add_executable(gfal_access        "gfal_access.c")
        target_link_libraries(gfal_access ${GFAL2_LINK})

        add_executable(gfal_checksum_tool        "gfal_checksum_tool.c")
        target_link_libraries(gfal_checksum_tool ${GFAL2_LINK})
        
        FUNCTION(stat_test_all name valid)
                add_test(gfal_stat_${name} gfal_stat ${valid})
        ENDFUNCTION(stat_test_all valid)

        FUNCTION(test_gfal_test_del_nonex name dir_path)
                add_test(gfal_test_del_nonex_${name} gfal_test_del_nonex ${dir_path})
        ENDFUNCTION(test_gfal_test_del_nonex name path)        

        FUNCTION(test_gfal_test_del name dir_path)
                add_test(gfal_test_del_${name} gfal_test_del ${dir_path})
        ENDFUNCTION(test_gfal_test_del name path)        

        FUNCTION(test_gfal_test_mkdir_unlink name dir_path)
                add_test(gfal_test_mkdir_unlink_${name} gfal_test_mkdir_unlink ${dir_path})
        ENDFUNCTION(test_gfal_test_mkdir_unlink name path)        

        FUNCTION(checksum_test_simple name dir_path algo)
                add_test(gfal_checksum_simple_${name} gfal_test_checksum ${dir_path} ${algo})
        ENDFUNCTION(checksum_test_simple name valid_file algo)
        
        FUNCTION(chmod_test_all name valid right1 right2 right3 right4)
                add_test(gfal_test_right_change_${name} gfal_test_right_change ${valid} ${right1} ${right2} ${right3} ${right4})
        ENDFUNCTION(chmod_test_all name valid right1 right2 right3 right4)        
        

        FUNCTION(rmdir_test_all name valid_dir)
                add_test(gfal_test_rmdir_full_${name} gfal_test_rmdir_full ${valid_dir})
        ENDFUNCTION(rmdir_test_all name valid_dir)
        
        FUNCTION(test_readdir_full name valid)
                add_test(gfal_test_readdir_full_${name} gfal_test_readdir_full ${valid})
        ENDFUNCTION(test_readdir_full valid)        

        FUNCTION(rwt_test_all name path size)
                add_test(gfal_rw_size_${name} gfal_test_rw_full ${path} ${size})
        ENDFUNCTION(rwt_test_all name path size)
        
        FUNCTION(rwt_test_seq name path size_read size)
                add_test(gfal_rw_seq_${name} gfal_test_rw_seq ${path} ${size_read} ${size})
        ENDFUNCTION(rwt_test_seq name path size_read size)
        
        FUNCTION(rwt_test_seek name path size_read size)
            add_test(gfal_rw_seek_${name} gfal_test_rw_seek ${path} ${size_read} ${size})
        ENDFUNCTION(rwt_test_seek name path size)
                
        add_executable(gfal_test_read        "gfal_test_read.c")
        target_link_libraries(gfal_test_read ${GFAL2_LINK} test_shared)
        
        add_executable(gfal_test_write        "gfal_test_write.c")
        target_link_libraries(gfal_test_write ${GFAL2_LINK} )        

        add_executable(gfal_test_rw        "gfal_test_rw.c")
        target_link_libraries(gfal_test_rw ${GFAL2_LINK})

        add_executable(gfal_test_del_nonex        "gfal_test_del_nonex.c")
        target_link_libraries(gfal_test_del_nonex ${GFAL2_LINK} test_shared)

        add_executable(gfal_test_del        "gfal_test_del.cpp") 
        target_link_libraries(gfal_test_del ${GFAL2_LINK} test_shared)
        
        add_executable(gfal_test_mkdir_unlink        "gfal_test_mkdir_unlink.c")
        target_link_libraries(gfal_test_mkdir_unlink ${GFAL2_LINK} test_shared)

        add_executable(gfal_test_rw_full        "gfal_test_rw_full.c")
        target_link_libraries(gfal_test_rw_full ${GFAL2_LINK} test_shared)
        
        add_executable(gfal_test_rw_seq        "gfal_test_rw_seq.c")
        target_link_libraries(gfal_test_rw_seq ${GFAL2_LINK} test_shared)
        
        add_executable(gfal_test_rw_seek        "gfal_test_rw_seek.c")
        target_link_libraries(gfal_test_rw_seek ${GFAL2_LINK} test_shared) 
        
        add_executable(gfal_test_get        "gfal_test_get.c")
        target_link_libraries(gfal_test_get ${GFAL2_LINK})
        
        add_executable(gfal_test_chmod        "gfal_test_chmod.c")
        target_link_libraries(gfal_test_chmod ${GFAL2_LINK})        

        add_executable(gfal_test_createdir        "gfal_test_createdir.c")
        target_link_libraries(gfal_test_createdir ${GFAL2_LINK} )

        add_executable(gfal_test_mkdir_full        "gfal_test_mkdir_full.c")
        target_link_libraries(gfal_test_mkdir_full ${GFAL2_LINK} ${GLIB2_PKG_LIBRARIES} test_shared)
        
        add_executable(gfal_test_right_change "gfal_test_right_change.c")
        target_link_libraries(gfal_test_right_change ${GFAL2_LINK} ${GLIB2_PKG_LIBRARIES} test_shared)
        
        add_executable(gfal_test_rmdir_full        "gfal_test_rmdir_full.c")
        target_link_libraries(gfal_test_rmdir_full ${GFAL2_LINK} ${GLIB2_PKG_LIBRARIES} test_shared)

        add_executable(gfal_test_readdir_full        "gfal_test_readdir_full.c")
        target_link_libraries(gfal_test_readdir_full ${GFAL2_LINK} ${GLIB2_PKG_LIBRARIES} test_shared)

        add_executable(gfal_ls        "gfal_ls.c")
        target_link_libraries(gfal_ls ${GFAL2_LINK} ${GLIB2_PKG_LIBRARIES})
   
        add_executable(gfal_bring_online "gfal_bring_online.c")
        target_link_libraries(gfal_bring_online ${GFAL2_LINK} ${GLIB2_PKG_LIBRARIES})
        
        add_executable(gfal_mv "gfal_mv.c")
        target_link_libraries(gfal_mv ${GFAL2_LINK} ${GLIB2_PKG_LIBRARIES})

        FUNCTION(mkdir_test_all name prefix)
                add_test(gfal_mkdir_full_${name} gfal_test_mkdir_full ${prefix})
        ENDFUNCTION(mkdir_test_all name prefix)        
        
        IF (MAIN_TRANSFER)

                add_executable(gfalt_copy_file "gfalt_copy_file.c")
                target_link_libraries(gfalt_copy_file ${GFAL2_TRANSFER_LINK} ${GFAL2_LINK})
                
                add_executable(gfalt_test_copy_file_cancel "gfalt_test_copy_file_cancel.cpp")
                target_link_libraries(gfalt_test_copy_file_cancel ${GFAL2_TRANSFER_LINK} ${GFAL2_LINK} ${CMAKE_THREAD_LIBS_INIT} pthread)

                add_executable(gfalt_copy_file_fts "gfalt_copy_file_fts.c")
                target_link_libraries(gfalt_copy_file_fts ${GFAL2_TRANSFER_LINK} ${GFAL2_LINK})

                add_executable(gfalt_copy_file_fts_thread "gfalt_copy_file_fts_thread.c")
                target_link_libraries(gfalt_copy_file_fts_thread ${GFAL2_TRANSFER_LINK} ${GFAL2_LINK} test_shared)

                add_executable(gfalt_copy_file_perf "gfalt_copy_file_perf.c")
                target_link_libraries(gfalt_copy_file_perf ${GFAL2_TRANSFER_LINK} ${GFAL2_LINK})
                
                add_executable(gfalt_test_copy_file "gfalt_test_copy_file.cpp")
                target_link_libraries(gfalt_test_copy_file ${GFAL2_TRANSFER_LINK} ${GFAL2_LINK} test_shared)

                add_executable(gfalt_test_copy_file_thead_safety "gfalt_test_copy_file_thead_safety.cpp")
                target_link_libraries(gfalt_test_copy_file_thead_safety ${GFAL2_TRANSFER_LINK} ${GFAL2_LINK} test_shared)

                add_executable(gfalt_test_copy_file_timeout "gfalt_test_copy_file_timeout.cpp")
                target_link_libraries(gfalt_test_copy_file_timeout ${GFAL2_TRANSFER_LINK} ${GFAL2_LINK} test_shared)
                
                add_executable(gfalt_test_copy_file_mkdir "gfalt_test_copy_file_mkdir.cpp")
                target_link_libraries(gfalt_test_copy_file_mkdir ${GFAL2_TRANSFER_LINK} ${GFAL2_LINK} test_shared)
                
                add_executable(gfalt_test_copy_file_replace "gfalt_test_copy_file_replace.cpp")
                target_link_libraries(gfalt_test_copy_file_replace ${GFAL2_TRANSFER_LINK} ${GFAL2_LINK} test_shared)

                add_executable(gfalt_test_copy_file_checksum "gfalt_test_copy_file_checksum.cpp")
                target_link_libraries(gfalt_test_copy_file_checksum ${GFAL2_TRANSFER_LINK} ${GFAL2_LINK} test_shared)

                add_executable(gfalt_test_copy_file_checksum_user "gfalt_test_copy_file_checksum_user.cpp")
                target_link_libraries(gfalt_test_copy_file_checksum_user ${GFAL2_TRANSFER_LINK} ${GFAL2_LINK} test_shared)
                
                add_executable(gfalt_test_copy_bulk "gfalt_test_copy_bulk.cpp")
                target_link_libraries(gfalt_test_copy_bulk ${GFAL2_TRANSFER_LINK} ${GFAL2_LINK} test_shared)
                
#                copy_files(${COPY_SRC} ${COPY_DST})
#                add_test(functional_copyfile gfal2_copyfile.sh)
#                add_test(functional_copyfile_srm gfal2_copyfile_srm.sh)
                
        FUNCTION(copy_file_test_full name src_dir dst_dir)
                add_test(copyfile_checksum_${name} gfalt_test_copy_file_checksum ${src_dir} ${dst_dir})
                add_test(copyfile_checksum_user_${name} gfalt_test_copy_file_checksum_user ${src_dir} ${dst_dir})
                add_test(copyfile_replace_${name} gfalt_test_copy_file_replace ${src_dir} ${dst_dir})
                add_test(copyfile_test_${name} gfalt_test_copy_file ${src_dir} ${dst_dir})
                add_test(copyfile_test_mkdir_${name} gfalt_test_copy_file_mkdir ${src_dir} ${dst_dir})
                add_test(copyfile_bulk_${name} gfalt_test_copy_bulk ${src_dir} ${dst_dir})
        ENDFUNCTION(copy_file_test_full name dst_dir)


        FUNCTION(copy_file_test_simple name src_dir dst_dir)
                add_test(copyfile_test_${name} gfalt_test_copy_file ${src_dir} ${dst_dir})
        ENDFUNCTION(copy_file_test_simple name src_dir dst_dir)


#        FUNCTION(copy_file_test_timeout name src_file dst_dir)
#                add_test(copy_file_test_timeout_${name} gfal_copyfile_test_timeout ${src_file} ${dst_dir})
#        ENDFUNCTION(copy_file_test_timeout name src_file dst_dir)

        ENDIF (MAIN_TRANSFER)

        include(functional-test-parameters.cmake)        
        
ENDIF  (FUNCTIONAL_TESTS)

=== test/stress-test/CMakeLists.txt ===
FILE(GLOB src_loadtest "gfalt_copyfile_fts_style_load_test.c")

IF (STRESS_TESTS)

        include_directories( "${CMAKE_SOURCE_DIR}/src "  "${CMAKE_SOURCE_DIR}/src/posix/"
                    ${GLIB2_PKG_INCLUDE_DIRS} ${NETTLE_PKG_INCLUDE_DIRS} )

        add_executable(fts_seq_copy_files	${src_loadtest})
        target_link_libraries(fts_seq_copy_files ${GFAL2_TRANSFER_LINK} ${GFAL2_LINK} test_shared)
	
ENDIF  (STRESS_TESTS)

=== test/unit/CMakeLists.txt ===

if(UNIT_TESTS)

find_package(GTEST)
include_directories(${PROJECT_SOURCE_DIR}/src ".")

add_subdirectory(plugins/srm)
add_subdirectory(plugins/gridftp)
add_subdirectory(plugins/file)
add_subdirectory(global)
add_subdirectory(cancel)
add_subdirectory(transfer)
add_subdirectory(uri)

endif(UNIT_TESTS)

=== src/core/transfer/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.6)

if (MAIN_TRANSFER)
        file (GLOB src_trans "*.cpp" )
        list (APPEND header_transfer "gfal_transfer.h" "gfal_transfer_types.h" "gfal_transfer_plugins.h")

        add_definitions( ${GLIB2_PKG_CFLAGS} ${GTHREAD2_PKG_CFLAGS} ${GLIBMM_PKG_CFLAGS})

        add_library(gfal2_transfer  SHARED ${src_trans} ${src_libcpp} ${src_exceptions} ${gfal2_utils_src})
        target_link_libraries(gfal2_transfer ${GLIB2_PKG_LIBRARIES} ${GTHREAD2_PKG_LIBRARIES})
        target_link_libraries(gfal2_transfer ${UUID_PKG_LIBRARIES} ${OUTPUT_NAME_MAIN} ${GLIBMM_PKG_LIBRARIES})

        set_target_properties(gfal2_transfer PROPERTIES
                                     LIBRARY_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/src/core
                                     VERSION ${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH}
                                     SOVERSION ${VERSION_MAJOR}
                                     CLEAN_DIRECT_OUTPUT 1
                                     OUTPUT_NAME "gfal_transfer")
        add_PkgConfigFile_for_Library("gfal_transfer.pc" gfal2_transfer 
                                       HEADER_DIRS "gfal2"
                                       DESCRIPTION "gfal_transfer pkgconfig file"
                                       REQUIRES "gfal2")

        install(TARGETS gfal2_transfer
        LIBRARY DESTINATION ${LIB_INSTALL_DIR} )
            
        install(FILES ${CMAKE_CURRENT_BINARY_DIR}/gfal_transfer.pc DESTINATION ${PKGCONFIG_FILES_DIR})
        install(FILES ${header_transfer} DESTINATION ${INCLUDE_INSTALL_DIR}/gfal2/transfer)
        install(FILES "README_TRANSFER"
                DESTINATION ${DOC_INSTALL_DIR})

endif (MAIN_TRANSFER)

=== src/plugins/file/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.6)


if (PLUGIN_FILE)
    file (GLOB src_file "*.c*")

    pkg_check_modules(ZLIB_PKG REQUIRED zlib)


    include_directories(${ZLIB_PKG_INCLUDE_DIRS})


    add_library (plugin_file SHARED ${src_file} ${gfal2_src_checksum})
    target_link_libraries (plugin_file gfal2 ${ZLIB_PKG_LIBRARIES})


    set_target_properties(plugin_file   PROPERTIES
                                LIBRARY_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/src
								CLEAN_DIRECT_OUTPUT 1
								OUTPUT_NAME "gfal_plugin_file"
								LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/plugins)

    install(TARGETS		plugin_file
	        LIBRARY		DESTINATION ${PLUGIN_INSTALL_DIR} )
	    
    install(FILES		"README_PLUGIN_FILE"
	    	DESTINATION ${DOC_INSTALL_DIR})	    

endif (PLUGIN_FILE)

=== src/plugins/gridftp/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.6)

if (PLUGIN_GRIDFTP)
    file (GLOB_RECURSE src_gridftp "*.c*")

    pkg_check_modules(GLOBUS_GASS_COPY_PKG REQUIRED globus-gass-copy)

    add_definitions( ${GLOBUS_GASS_COPY_PKG_CFLAGS})
    add_library (plugin_gridftp SHARED ${src_gridftp})

    target_link_libraries(plugin_gridftp gfal2 gfal2_transfer
			              ${GLOBUS_GASS_COPY_PKG_LIBRARIES}
                          gomp)
    include_directories(${GLOBUS_GASS_COPY_PKG_INCLUDE_DIRS}
	        			${GRIDFTP_IFCE_INCLUDE_DIRS} 	 
        				${GLIBMM_PKG_INCLUDE_DIRS})


    set_target_properties(plugin_gridftp    PROPERTIES
								LIBRARY_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/src
								CLEAN_DIRECT_OUTPUT 1
								OUTPUT_NAME "gfal_plugin_gridftp"
								LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/plugins)



    install(TARGETS		plugin_gridftp
	        LIBRARY		DESTINATION ${PLUGIN_INSTALL_DIR} )
	    
    install(FILES		"README_PLUGIN_GRIDFTP"
	    	DESTINATION ${DOC_INSTALL_DIR})	    

    # install gsiftp configuration files
    LIST(APPEND gsiftp_conf_file "${CMAKE_SOURCE_DIR}/dist/etc/gfal2.d/gsiftp_plugin.conf")
    install(FILES ${gsiftp_conf_file}
                        DESTINATION ${SYSCONF_INSTALL_DIR}/gfal2.d/)

endif (PLUGIN_GRIDFTP)

=== src/plugins/http/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.6)


if (PLUGIN_HTTP)
    include     (CheckLibraryExists)

    pkg_check_modules(DAVIX_PKG REQUIRED "davix>=0.3.5")
    pkg_check_modules(DAVIX_COPY_PKG REQUIRED "davix_copy>=0.3.5")


    # Includes
    include_directories (${CMAKE_CURRENT_BINARY_DIR})
    include_directories(${DAVIX_PKG_INCLUDE_DIRS})
    include_directories(${DAVIX_COPY_PKG_INCLUDE_DIRS})

    # link
    link_directories( ${DAVIX_PKG_LIBRARY_DIRS})
    link_directories( ${DAVIX_COPY_PKG_LIBRARY_DIRS})

    # definitions
    add_definitions (${DAVIX_PKG_CFLAGS})
    add_definitions (${DAVIX_COPY_PKG_CFLAGS})

    # Build plugin
    file (GLOB src_http "gfal_http_*.cpp")
    add_library (plugin_http SHARED ${src_http})

    target_link_libraries(plugin_http gfal2
                                      gfal2_transfer
                                      ${DAVIX_PKG_LIBRARIES}
                                      ${DAVIX_COPY_PKG_LIBRARIES})

    set_target_properties(plugin_http   PROPERTIES  CLEAN_DIRECT_OUTPUT 1
                                        OUTPUT_NAME "gfal_plugin_http"
                                        LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/plugins)

    # Install
    install(TARGETS plugin_http
            LIBRARY DESTINATION ${PLUGIN_INSTALL_DIR})
    install(FILES "README_PLUGIN_HTTP"
            DESTINATION ${DOC_INSTALL_DIR})    

    # install http configuration files
    LIST(APPEND http_conf_file "${CMAKE_SOURCE_DIR}/dist/etc/gfal2.d/http_plugin.conf")
    install(FILES ${http_conf_file}
                        DESTINATION ${SYSCONF_INSTALL_DIR}/gfal2.d/)

endif (PLUGIN_HTTP)

=== src/plugins/lfc/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.6)


if (PLUGIN_LFC)
    find_package (LFC REQUIRED)
    add_definitions (-D_REENTRANT)

    include_directories(${LFC_INCLUDE_DIR} ${LCGDM_INCLUDE_DIR} ${UUID_PKG_INCLUDE_DIR})

    file (GLOB src_lfc "*.c*")
    add_library (plugin_lfc SHARED ${src_lfc})

    target_link_libraries(plugin_lfc gfal2 gfal2_transfer ${LFC_LIBRARIES} ${UUID_PKG_LIBRARIES})

    set_target_properties(plugin_lfc PROPERTIES
                            CLEAN_DIRECT_OUTPUT 1
                            OUTPUT_NAME "gfal_plugin_lfc"
                            LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/plugins)

    install (TARGETS plugin_lfc
             LIBRARY DESTINATION ${PLUGIN_INSTALL_DIR})
    install (FILES "README_PLUGIN_LFC"
             DESTINATION ${DOC_INSTALL_DIR})


    # install lfc configuration files
    LIST(APPEND lfc_conf_file "${CMAKE_SOURCE_DIR}/dist/etc/gfal2.d/lfc_plugin.conf")
    install(FILES ${lfc_conf_file}
                        DESTINATION ${SYSCONF_INSTALL_DIR}/gfal2.d/)
endif (PLUGIN_LFC)

=== debian/changelog ===
gfal2 (2.7.8-2) unstable; urgency=medium

  * Fix kfreebsd and hurd compilation

 -- Mattias Ellert <mattias.ellert@fysast.uu.se>  Wed, 10 Dec 2014 17:35:56 +0100

gfal2 (2.7.8-1) unstable; urgency=medium

  * New upstream release
  * Drop gfal2-bad-string-fmt.patch, gfal2-davix-httpcode.patch,
    gfal2-davix-lseek64.patch and gfal2-gsiftp-session-reuse.patch
    (fixed upstream)
  * Fix segfault in a call to gfal2_set_error (patch from upstream)

 -- Mattias Ellert <mattias.ellert@fysast.uu.se>  Tue, 09 Dec 2014 08:27:00 +0100

gfal2 (2.6.8-1) unstable; urgency=medium

  * New upstream release
  * Drop patches gfal2-cthread.patch and gfal2-new-davix-errors.patch
    (fixed upstream)

 -- Mattias Ellert <mattias.ellert@fysast.uu.se>  Fri, 24 Oct 2014 13:45:36 +0200

=== debian/control ===
Source: gfal2
Priority: optional
Maintainer: Mattias Ellert <mattias.ellert@fysast.uu.se>
Build-Depends: debhelper (>= 8.0.0), cmake, doxygen, libglib2.0-dev, libglibmm-2.4-dev, libattr1-dev, libldap2-dev, uuid-dev, liblfc-dev, libdpm-dev, srm-ifce-dev (>= 1.21.3), dcap-dev, libglobus-gass-copy-dev, davix-dev (>= 0.3.4), pkg-config, libgtest-dev
Standards-Version: 3.9.6
Section: net
Homepage: http://dmc.web.cern.ch/

Package: gfal2
Architecture: any
Depends:  libgfal2-2 (= ${binary:Version}), libgfal-transfer2 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Recommends: gfal2-plugin-lfc (= ${binary:Version}), gfal2-plugin-rfio (= ${binary:Version}), gfal2-plugin-dcap (= ${binary:Version}), gfal2-plugin-srm (= ${binary:Version}), gfal2-plugin-gridftp (= ${binary:Version}), gfal2-plugin-http (= ${binary:Version})
Description: Grid file access library 2.0
 GFAL 2.0 offers an a single and simple POSIX-like API for the file
 operations in grids and cloud environments. The set of supported
 protocols depends on the gfal2 installed plugins.

Package: libgfal2-2
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Core of the Grid File access Library 2.0
 The main library of gfal2. The gfal protocol support relies on a
 plugin system.

Package: libgfal-transfer2
Section: libs
Architecture: any
Depends: libgfal2-2 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Description: File Transfer logic of gfal2
 gfal-transfer is the high level API for file transfer operations in
 gfal2. It supports third-party copy.

Package: libgfal2-dev
Section: libdevel
Architecture: any
Depends: libgfal2-2 (= ${binary:Version}), libgfal-transfer2 (= ${binary:Version}), libglib2.0-dev, libattr1-dev, ${misc:Depends}
Description: Development files of gfal2
 Development files for gfal2

Package: gfal2-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Description: Documentation for gfal2
 Documentation, doxygen and examples of gfal2.

Package: gfal2-plugin-lfc
Architecture: any
Depends: libgfal2-2 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Description: Provide the lfc access for gfal2
 Provide the lfc support (LFN://) for gfal2. The LFC plugin allows
 read-only POSIX operations for the LFC catalog.

Package: gfal2-plugin-rfio
Architecture: any
Depends: libgfal2-2 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Description: Provide the rfio access for gfal2
 Provide the rfio support (RFIO://) for gfal2. The rfio plugin
 provides the POSIX operations for the rfio URLs, the rfio protocol is
 used on the DPM and on the Castor storage systems.

Package: gfal2-plugin-dcap
Architecture: any
Depends: libgfal2-2 (= ${binary:Version}), dcap-tunnel-gsi, ${shlibs:Depends}, ${misc:Depends}
Description: Provide the dcap access for gfal2
 Provide the dcap support (GSIDCAP://, DCAP://) for gfal2. The dcap
 plugin provides the POSIX operations for the dcap URLs, the dcap
 protocol is used on the DCACHE storage system

Package: gfal2-plugin-srm
Architecture: any
Depends: libgfal2-2 (= ${binary:Version}), libgfal-srm-ifce1 (>= 1.21.3), ${shlibs:Depends}, ${misc:Depends}
Description: Provide the srm access for gfal2
 Provide the srm support (SRM://) for gfal2. The srm plugin provides
 the POSIX operations and the third party transfer support on the SRM
 URLs.

Package: gfal2-plugin-gridftp
Architecture: any
Depends: libgfal2-2 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Description: Provide the gridftp access for gfal2
 Provide the gridftp support (GSIFTP://) for gfal2. The gridftp plugin
 provides the POSIX operations and the third party transfer support on
 the GSIFTP URLs.

Package: gfal2-plugin-http
Architecture: any
Depends: libgfal2-2 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Description: Provide the http access for gfal2
 Provide the HTTP and WebDAV support for gfal2. The http plugin
 provides the POSIX operations and the third party transfer support on
 the HTTP URLs. This plugin is able to do third-party copy with WebDAV.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

-include /usr/share/dpkg/buildflags.mk

CFLAGS += $(CPPFLAGS)
CXXFLAGS += $(CPPFLAGS)

export CFLAGS CXXFLAGS LDFLAGS

%:
	dh $@

override_dh_auto_configure:
	ln -fs /usr/src/gtest test/gtest
	dh_auto_configure -- -DSYSCONF_INSTALL_DIR:PATH=/etc -DLIB_SUFFIX="" \
	   -DUNIT_TESTS=TRUE

override_dh_auto_build:
	dh_auto_build -- all doc

override_dh_install:
	mkdir -p debian/gfal2-doc/usr/share/doc/gfal2-doc
	mv debian/tmp/usr/share/doc/gfal2/examples \
	   debian/tmp/usr/share/doc/gfal2/html \
	   debian/gfal2-doc/usr/share/doc/gfal2-doc
	rm -rf debian/tmp/usr/share/doc
	dh_install --fail-missing

override_dh_auto_clean:
	rm -f test/gtest
	dh_auto_clean

override_dh_auto_test:
	objdir=`ls -d obj-*` ; \
	export GFAL_PLUGIN_DIR=$(CURDIR)/$${objdir}/plugins ; \
	export GFAL_CONFIG_DIR=$(CURDIR)/$${objdir}/test/conf_test ; \
	dh_auto_test -- "ARGS+=-V"

## gfal2 2.9.1

=== CMakeLists.txt ===
## cmake build script for srm-ifce
project (gfal2)
cmake_minimum_required (VERSION 2.6)
message ("cmake source dir : ${CMAKE_SOURCE_DIR}")

# default set of options
set (MAIN_CORE      TRUE CACHE STRING "enable compilation of the main library")
set (MAIN_TRANSFER  TRUE CACHE STRING "enable compilation of the transfer library")
set (PLUGIN_LFC     TRUE CACHE STRING "enable compilation of the lfc plugin")
set (PLUGIN_SRM     TRUE CACHE STRING "enable compilation of the srm plugin")
set (PLUGIN_RFIO    TRUE CACHE STRING "enable compilation of the RFIO plugin")
set (PLUGIN_DCAP    TRUE CACHE STRING "enable compilation of the DCAP plugin")
set (PLUGIN_FILE    TRUE CACHE STRING "enable compilation of the local File plugin")
set (PLUGIN_GRIDFTP TRUE CACHE STRING "enable compilation of the GRIDFTP plugin")
set (PLUGIN_HTTP    TRUE CACHE STRING "enable compilation of the HTTP plugin")
set (PLUGIN_MOCK    FALSE CACHE STRING "enable compilation of the MOCK plugin")

# build type
set (CMAKE_BUILD_TYPE "RelWithDebInfo" CACHE STRING "type of build")

set (CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake/modules/")

# load modules
include(DefineInstallationPaths REQUIRED)
include(MacroCopyFile REQUIRED)
include(ReleaseDebugAutoFlags REQUIRED)
include(CMakeGeneratePkgConfig REQUIRED)
include(MacroAddDoxygen REQUIRED)
include(CMakeCXX11Support REQUIRED)

# Enable C++11 support
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${CXX11_FLAG_ENABLE}")

# enable testing
include (CTest)

#define PROJECT vars
set (PROJECT_NAME_MAIN "gfal2")
set (OUTPUT_NAME_MAIN "gfal2")

set (PROJECT_NAME_TRANSFER "gfal_transfer")
set (OUTPUT_NAME_TRANSFER "gfal_transfer")

set (VERSION_MAJOR  2)
set (VERSION_MINOR  9)
set (VERSION_PATCH  1)
set (VERSION_STRING ${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH})

add_definitions(-DVERSION="${VERSION_STRING}")

# out of project test compilation
set (ONLY_TESTS FALSE CACHE STRING "build only the tests")
set (SKIP_TESTS FALSE CACHE STRING "skip the tests")

# libs checks
find_package (GLIB2 REQUIRED)
find_package (GTHREAD2 REQUIRED)

# include directories
include_directories (${GLIB2_INCLUDE_DIRS})
include_directories (${GTHREAD2_INCLUDE_DIRS})
include_directories (${CMAKE_SOURCE_DIR}/src/core)
include_directories (${CMAKE_SOURCE_DIR}/src/utils)

# Core and plugins
if (NOT ONLY_TESTS)
    find_package (UUID REQUIRED)
    
    # general parameters for configuration
    add_definitions ( -DGFAL_PLUGIN_DIR_DEFAULT="${PLUGIN_INSTALL_DIR}" )
    add_definitions ( -DGFAL_CONFIG_DIR_DEFAULT="${SYSCONF_INSTALL_DIR}" )
    # add file offset 64 for 32 bits
    add_definitions ( -D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE -D_LARGEFILE64_SOURCE -D_GNU_SOURCE)

    #install doc license
    install (FILES "LICENSE" "README" "RELEASE-NOTES" "DESCRIPTION" "readme.html"
			 DESTINATION ${DOC_INSTALL_DIR})
			
    # install global configuration files
    list (APPEND lst_conf_files "${CMAKE_SOURCE_DIR}/dist/etc/gfal2.d/gfal2_core.conf" "${CMAKE_SOURCE_DIR}/dist/etc/gfal2.d/bdii.conf")
    install (FILES ${lst_conf_files}
             DESTINATION ${SYSCONF_INSTALL_DIR}/gfal2.d/)

    add_subdirectory (doc)
    add_subdirectory (src)

endif (NOT ONLY_TESTS)

if (NOT SKIP_TESTS)
    add_subdirectory (test)
endif (NOT SKIP_TESTS)
